import React, {useRef, useState} from 'react';
import {Input, Menu, Modal} from 'antd';
import {updateFileName} from "../../../utils/File";
import {useDispatch} from "react-redux";
import {updateFileName as updateFileNameRedux} from "../../../redux/dirMessage_reducer";
import {updateFileName as updateFileNameBar} from "../../../redux/tableBarItem_reducer";
import {replaceFileNameByFilePath} from "../../../utils/PathOperate";

const UpdateFileName = (prop) => {
    console.log("prop",prop)
    const [isModalOpen, setIsModalOpen] = useState(false);
    const dispatch = useDispatch();
    const inputValue = useRef(null);
    const showModal = () => {
        setIsModalOpen(true);
    };
    const handleOk = () => {
        setIsModalOpen(false);
        console.log("inputValue",inputValue.current.input.value)
        // 修改文件名不修改文件扩展名
        // 如果和原始名称一样，关闭菜单直接返回
        // 如果不一样，修改文件名并且更新树，同步条目
        if (prop.fileName!==inputValue.current.input.value){
            // 修改文件名，新文件地址
            let newFilePath= replaceFileNameByFilePath(prop.filePath,inputValue.current.input.value)
            updateFileName(prop.filePath,newFilePath)
            // 更新树
            dispatch(updateFileNameRedux({"oldFilePath":prop.filePath,"newFilePath":newFilePath}))
            // 同步条目
            dispatch(updateFileNameBar({"oldFilePath":prop.filePath,"newFilePath":newFilePath}))

        }
    };
    const handleCancel = () => {
        setIsModalOpen(false);
    };
    return (
        <>
            <span className="menuItemClick" onClick={showModal}>修改文件名</span>
            <Modal title="修改文件名" open={isModalOpen} onOk={handleOk} onCancel={handleCancel}>
                <Input ref={inputValue} placeholder={prop.fileName} />
            </Modal>
        </>
    );
};
export default UpdateFileName;