import { createSlice } from '@reduxjs/toolkit'

export const historyRecordSlice = createSlice({
    name: 'historyRecord',
    initialState: {
        data: []
    },
    reducers: {
        historyRecordSync: (state, action) => {
            console.log("reducers:HISTORY_SYNC", state, action)
            if(action.payload.length>0){
                state.data =[...action.payload,...state.data.slice(0,state.data.length-action.payload.length)]
            }
            
        },
        historyRecordSearch: (state, action) => {
            console.log("reducers:historySearch", state, action)
            state.data = action.payload
        }
    }
})
export const { historyRecordSync, historyRecordSearch } = historyRecordSlice.actions

export default historyRecordSlice.reducer
